//+------------------------------------------------------------------+
//|                                                        Stoch.mq4 |
//|                      Copyright  2010, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2010, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

//---- input parameters
extern int        razn=0;
extern int        Shift=1;
extern int        Period_MA=21;
extern double     Lots=0.01;
extern double     razn1;
extern int        timeframe = 240;
//extern int        stop_loss = 20;
extern int        takeprofit = 50;

int TimeBar;
int handle;
int i=0;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   razn1 = razn/10000; 
   handle = 0;     
   if (handle==0) {
      handle=FileOpen("my_data.txt",FILE_WRITE,';');
      if(handle<1)
      {
         Print(" my_data.txt  ,   ", GetLastError());
         return;
      }
   }
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
FileClose(handle);      
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  { 
//----
if (TimeBar==Time[0]) return(0);
if (TimeBar==0) {TimeBar=Time[0];return(0);}//  
double stochMain0 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_MAIN,0);
double stochSIGNAL0 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_SIGNAL,0);
double stochMain_1 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_MAIN,1);
double stochSIGNAL_1 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_SIGNAL,1);
double stochMain_4 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_MAIN,4);
double stochSIGNAL_4 = iStochastic(NULL,timeframe,5,3,3,MODE_SMA,0,MODE_SIGNAL,4);

if (OrdersTotal()!=0) {
   if (OrderType()==OP_BUY && stochMain0<stochSIGNAL0) CLOSEORDER("Buy");     //  && stochMain_1<stochSIGNAL_1
   if (OrderType()==OP_SELL && stochMain0>stochSIGNAL0) CLOSEORDER("Sell");   //  && stochMain_1>stochSIGNAL_1
}
else {
   double MA0 = iMA(NULL,timeframe,Period_MA,0,MODE_SMA, PRICE_CLOSE,0);   
   double MA1 = iMA(NULL,timeframe,Period_MA,0,MODE_SMA, PRICE_CLOSE,Shift);   
   double MA2 = iMA(NULL,timeframe,Period_MA,0,MODE_SMA, PRICE_CLOSE,Shift*2); 
   if (MA0>MA1-razn1 && MA1>MA2-razn1 && MA0<Ask)    //    (iRSI(NULL,timeframe,14,PRICE_CLOSE,0)>53) 
      if(stochMain0>stochSIGNAL0 && stochMain_1>stochSIGNAL_1 && stochMain_4<stochSIGNAL_4) {
         i++;
         FileWrite(handle, i);  //if (handle > 0) 
         //OPENORDER ("Buy");
         OrderSend(Symbol(),OP_BUY, Lots,Ask,3,Ask-20*Point,0,"", 0,0,Blue);
      }
   else if (MA0+razn1<MA1 && MA1+razn1<MA2 && MA0>Bid)      //      (iRSI(NULL,timeframe,14,PRICE_CLOSE,0)<47)
      if(stochMain0<stochSIGNAL0 && stochMain_1<stochSIGNAL_1 && stochMain_4>stochSIGNAL_4)  //   
         {OPENORDER ("Sell");  Print("Open order SELL");}
}     
TimeBar=Time[0]; 

//----
   return(0);
  }
//+------------------------------------------------------------------+

//--------------------------------------------------------------------
void CLOSEORDER(string ord)
{
   for (int i=OrdersTotal()-1; i>=0; i--)
   {                                               
      if (OrderSelect(i,SELECT_BY_POS,MODE_TRADES)==true)
      {
         if (OrderSymbol()!=Symbol()) continue;
         if (OrderType()==OP_BUY && ord=="Buy")
            OrderClose(OrderTicket(),OrderLots(),Bid,3,Blue);// Close Buy
         if (OrderType()==OP_SELL && ord=="Sell")
            OrderClose(OrderTicket(),OrderLots(),Ask,3,Red);// Close Sell
      }   
   }
}
//--------------------------------------------------------------------//--------------------------------------------------------------------
void OPENORDER(string ord)
{
   int error;
   
   if (ord=="Buy" ) error=OrderSend(Symbol(),OP_BUY, Lots,Ask,3,Ask-15*Point,0,"", 0,0,Blue);   // Ask-stop_loss*Point
   if (ord=="Sell") error=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Bid+15*Point,0,"",0,0,Red);    // Bid+stop_loss*Point
   if (error==-1) //  OK
   {  
      ShowERROR(error,0,0);
   }
return;
}                  
//--------------------------------------------------------------------
void ShowERROR(int Ticket,double SL,double TP)
{
   int err=GetLastError();
   if (handle > 1) FileWrite(handle, err);
   switch ( err )
   {                  
      case 1:                                                                               return;
      case 2:   Alert("       "              ,Ticket," ",Symbol());return;
      case 3:   Alert("Error      Ticket ",       Ticket," ",Symbol());return;
      case 130: Alert("Error     Ticket ",                 Ticket," ",Symbol());return;
      case 134: Alert("    ",                         Ticket," ",Symbol());return;
      case 146: Alert("Error    ",             Ticket," ",Symbol());return;
      case 129: Alert("Error   ",                      Ticket," ",Symbol());return;
      case 131: Alert("Error   ",                     Ticket," ",Symbol());return;
      case 4051:Alert("Error     ",Ticket," ",Symbol());return;
      case 4105:Alert("Error      ",                Ticket," ",Symbol());return;
      case 4063:Alert("Error    integer ",        Ticket," ",Symbol());return;
      case 4200:Alert("Error    ",                  Ticket," ",Symbol());return;
      default:  Alert("Error  " ,err,"   Ticket ",                     Ticket," ",Symbol());return;
   }
}
//--------------------------------------------------------------------
/*double LOT(int risk,int ord)
{
   double MINLOT = MarketInfo(Symbol(),MODE_MINLOT);
   LOT = AccountFreeMargin()*risk/100/MarketInfo(Symbol(),MODE_MARGINREQUIRED)/ord;
   if (LOT>MarketInfo(Symbol(),MODE_MAXLOT)) LOT = MarketInfo(Symbol(),MODE_MAXLOT);
   if (LOT<MINLOT) LOT = MINLOT;
   if (MINLOT<0.1) LOT = NormalizeDouble(LOT,2); else LOT = NormalizeDouble(LOT,1);
   return(LOT);
}*/

